// ################################################################################################################
//
//		GrandPiano.js
//
//		muss vor silverlight.js geladen werden
//
//		anzupassende JavaScript-Daten    zum Grand Piano
//		anzupassende JavaScript-Routinen zum Grand-Piano
//
//		Hinweis: Es gibt noch XAML-Daten in der GrandPiano.xaml
//				nderungen in der XAML-Datei knnen JavaScript-Daten beeinflussen (siehe unten)
//
//		JS-Datei wird von silverlight.js bentigt:
//			Es werden Variablen erzeugt, die ij silverlight.js gelesen werden:
//							X1_SilverlightControl_Version
//							X1_SilverlightControlHost_ID
//							X1_Daten_OBJECT_ElementeBezeichner
//							X1_Daten_PARAM_ElementeBezeichner
//							X1_Silverlight_DatenElementeBezeichner
//							X1_Silverlight_DatenElementeBezeichner_parentElement_Index
//							X1_Silverlight_DatenElementeBezeichner_events_Index
//							X1_Silverlight_DatenElementeBezeichner_onError_Index
//							X1_Silverlight_DatenElementeBezeichner_onLoad_Index
//							X1_SilverlightDaten
//							X1_GrandPiano
//
//			aufbereitete JS-Datei anhand der Programmcode der Microsoft-programmierten JS-Dateien
//							silverlight.js
//							createsilverlight.js
//			Aufbereitung
//				erfolgt damit 	Quelltext lesbar wird
//						 	Programmlogik erkennbar wird
//				mit Entfernung aller Logik- und Programmierungsfehler, die von Microsoft eingebaut wurden
//			Sollte Der Internet Exlorer mit Start der index.html regelmig einen Adressfehler bringen,
//						der auch die Adresse 0x00000000 umfassen kann, ist das Silverlight-ActiveX-Control
//						defekt und es muss neu installiert werden: Dazu lade man sich die aktuellen Updates
//							zum IE per http://msdn2.microsoft.com/en-us/library/bb188743.aspx
//							zu Silverlight per http://silverlight.net/Default.aspx
//						herunter und installiere diese. Man beachte Nicht-Kompatibitt von
//						Silverlight-Varianten (inkl. deren Beta-Versionen).
//			WARNUNG: Microsoft zeigt mit seiner JS-Datei, wie man NICHT prorgrammieren sollte:
//						Es werden Daten und Programmcode munter gemixt, so dass der
//							Quellcode nur als wertlose Einzelfall-Lsung dient.
//						Silverlight wird datenseitig konsequent NICHT dynamisch programmiert:
//							Daten liegen teilweise als Programmcode-Teile vor und zwar derart
//								festkodiert, dass deren Kapselung eine vllig andere Programmlogik
//								erzwingt, die aber Voraussetzung fr dynamische Webseiten mit
//								geringem Pflegeaufwand ist.
//						   Microsoft zeigt mit der Einzelfall-Lsung, dass die Programmierung mit
//								Silverlight nicht jedermanns Sache bei Microsoft ist.
//						   Es werden Konzeptfehler on Silverlight sichtbar: Daten und Programmcode 
//								der Anwendung sind von denen, die das Silverlight-Laufzeitsystem bentigt,
//								nur schwer trennbar, so dass deren Verqickung IMMER eine Einzelfalllsung
//								darstellt, wenn nicht gengend Programmierungsaufwand betrieben wird.
//							Mit anderen Worten: Es muss zwingend geprft werden, ob Trennung mglich
//								ist: Wenn nein, sollte das Projekt mit anderer Laufzeitumgebung als 
//								Silverlight geschrieben werden: Einzellsungen sind meist supportaufwendig
//								und die Kinderkrankheiten des programmierten Silverlight-Konzpetes
//								sind genau genommen einfach nur Mll - und das als Aushngeschild per
//								Grand-Piano mit Microsoft-Signatur.
//						Faulheiten des Programmieres fhrt zu uneinheitlichem Quelltext als Einzellsung:
//							Die Verwendung von Variablennamen ist Elend pur und gleicht dem von Anfngern.
//							Wegen Faulheit werden beim Codieren werden Anweisungen verwendet, deren
//								Komplexitt mehr Laufzeit kostet, als bei Verwendung einfacher
//								Anweisungen.
//							Vorgaben von Microsoft zur Quelltext-Optimierung im Sinne der
//								Script-Laufzeit-Optimierung werden konsequent ignoriert.
//				Die Aufarbeitung des Quellcode zeigt Anstze, wo dynamische Programmierung
//						notwendig und sinnvoll ist, ersetzt aber die vom Microsoft-Programmierer
//						verwendete Logik nicht komplett (aus Mist lsst sich kein Gold machen),
//						da ansonsten die Anwendung komplett neu programmiert werden msste.
//						Die Verwendung von HTTPRequest zur Daten- und Script-Programmcode-Beschaffung
//						zur Laufzeit ist nicht eingebaut worden, empfiehlt sich aber.
//				Die Routinen sollten mglichst als eigenstndiges System unabhngig von Zeigern von Silverlight
//						programmiert werden und ber Silverlight-Variablen bzw. -Zeiger referenziert werden
//						(z.B. Zeiger auf Funktion kopieren nach Silverlight-Funktionsvariable).
//						Silverlight wird von Microsoft permanent verndert und
//						Schnittstellenkonsistenz ist Sache von Microsoft: Werden Schnittstellen verndert,
//						so sind wenigstens die Routinen als System unberhrt und der Fehler ist schneller
//						findbar.
//			Microsoft will anhand Silverlight seine (sau teueren) Developer-Produkte wie Visual
//			und Co. verkaufen (Testversionen sind zeitlich limitiert) und zugleich ASP 
//			in die Adobe-Flash-Konkurrenz drcken - allerdings ist das mehr ein Eigentor.
//			Alternativen zur Silverlight-Technik gabs schon seit 1998 (also rechtzeitig VOR Adobe Flash
//			und als Betriebsystemkomponenten, auf die u.a. auch Office-Powerpoint aufbaute (bis hin zur
//			Timeline-Programmierung per HTML, JavaScript oder VBasic) in DirectX mit Direct3D und DirectMedia
//			(inklusive HTML- und Javascript-Schnittstelle + kostenlosem SDK fr Web-Desing), die aber 
//			inzwischen von Microsoft ersatzlos und gnadenlos entfernt wurden (u.a. mit der Begrndung,
//			dass neueres Windows neuere und sichere Schnittstellen bentigt). Die Abschaltung ist allerdings
//			ganz klar ein Analogon zum Wechsel des Treibersystems zwischen Win XP SP1 und 2 sowie erneut von
//			Win XP zu Win Vista (verbunden mit Folgekosten (abgesehen von Hardwarekosten): User, die weiterhin
//			Schnittstellen fr Webseiten mit Animation auf DirectX-Basis nutzen wollen, werden gnadenlos vom Markt
//			gefegt: Sie mssen umstellen (und so auch Developer-Produkte kaufen) oder zur Konkurrenz wechseln,
//			denn ein hherer Programmierungsaufwand lohnt nur bei dauerhafteren Schnittstellensystemen).
//			DirectX wurde gezielt nicht mehr abwrtskompatibel gehalten, da zustzlich Net-Framework durchgedrckt
//			werden soll (Pendant zu Sun Java): Silverlight + DirectX mit Net-Framework sollen zusammenarbeiten - 
//			mglichst mit ASP und das mit Browsern wie Safari oder Firefox. (Net-Framwork ist in Versionen parallel
//			installierbar, Silverlight jedoch nicht).
//
// Smtliche Entwicklungstools der Express-Serie (Blend, Media etc.) gibt es
//	als Trial fr einen begrenzem Laufzeitraum und sind ansonsten zu kaufen.
//
//  Microsoft Expression Blend Free Trial
//
//		We are pleased to present a trial version of Microsoft Expression Blend. 
//		This fully functioning version will expire 60 days after installation. 
//		This trial can be unlocked when you receive your purchased copy of the 
//		product by entering the product key found on the box.
//
//		Die Vollversion kostet 600 US-Dollar
//
// Microsoft Expression Studio (Free evaluation is available for download)
//
//	ist als Trial in Komponenten zerlegt, die verschiedene Laufzeiten haben
//		z.B.
//
//		  	Microsoft Expression Blend Free Trial
//
//			We are pleased to present a trial version of Microsoft Expression Blend. 
//			This fully functioning version will expire 60 days after installation. 
//			This trial can be unlocked when you receive your purchased copy of the 
//			product by entering the product key found on the box.
//
//
//	Whether creating standards-based Web user interfaces by using Microsoft ASP.NET, 
//		building cross-platform rich interactive applications with Silverlight, 
//		or creating ultimate Windows Vista experiences with Windows Presentation 
//		Foundation (WPF), Expression tools enable designers to fully apply their 
//		creativity while collaborating with developers using Microsoft Visual Studio. 
//		Expression Studio includes the following products:
//			Expression Web for building standards-based Web sites.
//			Expression Design for professional illustration and graphic design.
//			Expression Blend for creating engaging Web-connected experiences for Microsoft Windows. 
//			This special preview version is compatible with creating content for Silverlight 1.0 
//				Release Candidate and Silverlight 1.1 Alpha.
//			Expression Media for assets management as well as media encoding. 
//				This version also includes the Expression Encoder tool for transcoding video content. 
//
//
//   Windows Movie Maker
//
//
//	Import audio and video to your computer from a digital video camera, and then use the 
//	imported content in your movies. You can also import existing audio, video, or still 
//	pictures into Windows Movie Maker to use in the movies you create. After editing the audio 
//	and video content in Windows Movie Maker, which can include adding titles, transitions, 
//	or effects, you can then publish your final movie and share it with your friends and family. 
//	Windows Movie Maker is also available for Microsoft Windows XP.
//
//
// ################################################################################################################


// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//
//          anzupassende Daten
//
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


// +++++ XAML-Datenquelle +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Bild- und Sound sind paarweise verfgbar und haben im Paar IDENTISCHEN Prfix, der
//		als PianoTastenID verwendet wird
//		als Suffix in x:Name von Elementen des Canvas laut X1_XAML_pathCanvas in der XAML-Datei verwendet wird
//          als Prfix in x:Name von Image und MediaElement in der XAML-Datei verwendet wird
//	Fr alle Elemente eines Canvas sollte der Wert von x:Name einmalig sein (nicht mehrfach auftreten).
var X1_SilverlightControl_XAML_Source="GrandPiano.xaml";

// +++++ Silverlight-Eigenschaften als HTML-Objekt (OBJECT bzw. EMBED) ++++++++++++++++++++++++++++++++++++++++++
var X1_SilverlightControl_Breite="1024";			
var X1_SilverlightControl_Hoehe="530";
var X1_SilverlightControl_Background_Farbe="white";
var X1_SilverlightControl_Fensterrahmen="false";
var X1_SilverlightControl_maxFramerate="25";

// +++++ Version ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
var X1_SilverlightControl_Version="0.9";		// wird von silverlight.js gelesen

// +++++ ID des Containers (Eltern) des Silverlight-HTML-Objektes laut index.html
var X1_SilverlightControlHost_ID="SilverlightControlHost";  // ID des DIV-Container des Silverlight-Objektes
										// Container in index.html erzeugt
										// wird von silverlight.js gelesen

// +++++ ID des Silverlight-HTML-Objektes (OBJECT bzw. EMBED) +++++++++++++++++++++++++++++++++++++++++++++++++++
var X1_SilverlightControl_ID="SilverlightControl_ID";		// frei whlbar

// +++++ Datenstruktur zur Versorgung des Silverlight-HTML-Objektes mit Daten +++++++++++++++++++++++++++++++++++
// Silverlight wird mit einer Datenstruktur versorgt.
// Silverlight wird per HTML-Objekt erzeugt: OBJECT bzw. EMBED
// Damit mssen Elemente, deren Werte, das HTML-Objekt versorgen, im Bezeichner konform mit den Attributen
//		zum HTML-Objekt sein.
// OBJECT erhlt zustzlich PARAM, so dass Struktur-Elemente PARAM versorgen mssen

// ----- Elemente der Datenstruktur: Bezeichner -----------------------------------------------------------------

var X1_Silverlight_DatenElementeBezeichner=new Array	// indexsynchron zu X1_Silverlight_DatenElementeWerte
									// wird von silverlight.js gelesen
// Feld der Bezeichner u.a. von Attributen des OBJECT-Tags
//				                   des PARAM-Tag
// Bezeichner darf nicht doppelt auftauchen
//	nicht verwendbare Bezeichner -->  siehe Plficht-Elemente
// Bezeichner fr Events
//	Es gibt die Eventstruktur als Pflicht-Element, das weitere Pflichtelemente umfassen kann (siehe dort)
//		Zustzliche zu den Pflichtelementen) bentigte Bezeichner fr Eventsstruktur-Elemente
//			mssen spter per Punktnotation verwendet werden (wie die Pflichtelemente in der Eventstruktur)
//			Bsp.:  Eventstruktur  events
//					Pflichtelement  onload		also Adressierung per events.onload
//    Hinweis: Anstelle Punktnotation ist auch Index-Adressierung per Array mglich, wobei der Index
//			eine Stringvariable ist, die den Bezeichner des Elementes enthlt, und das Feldelement
//			den Wert des Elementes.
//			Bsp.:	Datenstruktur.souce      identisch mit   Index='source';  Datenstruktur[Index] 
//		  Jeder Punkt zeigt einen Unter-Index an
//			Bsp.: Datenstruktur.properties.width  identisch mit    
//					Datenstruktur['properties']['widht']
// Kleinschreibung zulssig fr Attribute in HTML-Tags
('source',			// 0 PARAM-Attribut  fr OBJECT
 'id',			// 1 ID-Attribut     des OBJECT-Tags
 'width',			// 2 WIDHT-Attribut  des OBJECT-Tags
 'height',			// 3 HEIGHT-Attribut des OBJECT-Tags
 'background',		// 4 PARAM-Attribut  fr OBJECT
 'windowless',		// 5 PARAM-Attribut  fr OBJECT
 'maxFramerate'		// 6 PARAM-Attribut  fr OBJECT
);

var X1_Silverlight_DatenElementeBezeichner_soucre_Index=0;		// 'source'
var X1_Silverlight_DatenElementeBezeichner_id_Index=1;		// 'id'
var X1_Silverlight_DatenElementeBezeichner_width_Index=2;		// 'width'
var X1_Silverlight_DatenElementeBezeichner_heigth_Index=3;		// 'height'
var X1_Silverlight_DatenElementeBezeichner_background_Index=4;	// 'background'
var X1_Silverlight_DatenElementeBezeichner_windowless_Index=5;	// 'windowless'
var X1_Silverlight_DatenElementeBezeichner_maxFramerate_Index=6;	// 'maxFramerate'

// ----- Elemente der Datenstruktur: Werte ----------------------------------------------------------------------

var X1_Silverlight_DatenElementeWerte=new Array		// indexsynchron zu X1_Silverlight_DatenElementeBezeichner
(X1_SilverlightControl_XAML_Source,		// source
 X1_SilverlightControl_ID,			// id
 X1_SilverlightControl_Breite,		// width
 X1_SilverlightControl_Hoehe,			// height
 X1_SilverlightControl_Background_Farbe, 	// background
 X1_SilverlightControl_Fensterrahmen,   	// windowless
 X1_SilverlightControl_maxFramerate		// maxFramerate
);

// ----- Datenelemente aus X1_Silverlight_DatenElementeBezeichner fr Erzeugung des
//			des Silverlight-HTML-Objektes als OBJECT
var X1_Daten_OBJECT_ElementeBezeichner=new Array 	// wird von silverlight.js gelesen
// Datenlemente werden in X_Daten_OBJECT hinterlegt
// Reihenfolge egal
(X1_Silverlight_DatenElementeBezeichner[X1_Silverlight_DatenElementeBezeichner_id_Index],		// 'id'
 X1_Silverlight_DatenElementeBezeichner[X1_Silverlight_DatenElementeBezeichner_width_Index],	// 'width
 X1_Silverlight_DatenElementeBezeichner[X1_Silverlight_DatenElementeBezeichner_heigth_Index] 	// 'height'
);

// ----- Datenelemente aus X1_Silverlight_DatenElementeBezeichner fr Erzeugung der PARAM im OBJECT 
//			des Silverlight-HTML-Objektes 
var X1_Daten_PARAM_ElementeBezeichner=new Array		// wird von silverlight.js gelesen
// Datenelemente werden in X_Daten_PARAM hinterlegt
// Reihenfolge egal
(X1_Silverlight_DatenElementeBezeichner[X1_Silverlight_DatenElementeBezeichner_soucre_Index],		// 'source',
 X1_Silverlight_DatenElementeBezeichner[X1_Silverlight_DatenElementeBezeichner_background_Index],	// 'background'
 X1_Silverlight_DatenElementeBezeichner[X1_Silverlight_DatenElementeBezeichner_windowless_Index],	// 'windowless',
 X1_Silverlight_DatenElementeBezeichner[X1_Silverlight_DatenElementeBezeichner_maxFramerate_Index]	// 'maxFramerate',
)

// +++++ Kennungen aus der XAML-Datei hier ebenfalls ablegen ++++++++++++++++++++++++++++++++++++++++++++++++++++
// Bild- und Sound sind paarweise verfgbar und haben im Paar IDENTISCHEN Prfix, der
//		als PianoTastenID verwendet wird
//		als Suffix in x:Name von Elementen des Canvas laut X1_XAML_pathCanvas in der XAML-Datei verwendet wird
//          als Prfix in x:Name von Image und MediaElement in der XAML-Datei verwendet wird
//	Fr alle Elemente eines Canvas sollte der Wert von x:Name einmalig sein (nicht mehrfach auftreten).

var X1_XAML_pathCancas_xName_Suffix='Path';// laut XAML-Datei fr element im Canvas laut X1_XAML_pathCanvas
var X1_XAML_pathCanvas='pathCanvas';		// laut XAML-Datei
var X1_XAML_IMG_xName_Praefix='img';		// laut XAML-Datei fr Bild-Datei  in x:Name
var X1_XAML_Sound_xName_Praefix='snd';	// laut XAML-Datei fr Sound-Datei in x:Name

// +++++ Zuordnung Key-Code (Tasten-Code und NICHT Zeichenkode) zu den Bild- und Sounddateien,
//		die bei passendem Tastedruck aktiviert werden sollen.
//	    Dateinamen haben ZWINGEND (wegen XAML-Datei und Angaben dort) folgenden Aufbau 
//			Prfix	Ton  wie C2 oder B
//			Suffix	je nach Medienart z.B. JPG
//	    Ton wird musiktechnisch mit Buchstaben bezeichnet z.B. C  oder C2 fr Cis bzw. C#
//					Der Buchstabe wird als PianoTastenID bezeichnet.
//	    Key-Code werden den Tonbuchstaben zugeordnet

var X1_DateiPraefix_BildUndSound=new Array();// Zuordnung Key-Code zu PianotastenID
							// Index ist Key-Code und nicht ASCII-Code
							//     Key-Code 55 ist ASCII '7'

// ----- allen Keycodes von 0 bis 255 den Standard-Buchstaben 'C' verpassen (PianoTastenID 'C')
for(var X1_Zahler=0;X1_Zahler<256;X1_Zahler++)	// den Key-Code 0 bis 256 
{X1_DateiPraefix_BildUndSound[X1_Zahler]='C';}     //  einen Standard 'C' zuordnen (PianoTastenID 'C')

// ----- Keycodes mit anderem ID belegen (einfach ausprobieren, je nach Geschmack)
X1_DateiPraefix_BildUndSound[55]='C';		//               linkeste klickbare weisse   Taste
X1_DateiPraefix_BildUndSound[48]='C2';		// C# oder D-es, linkeste klikcbare schwarze Taste
X1_DateiPraefix_BildUndSound[53]='D';		//               weisse Taste
X1_DateiPraefix_BildUndSound[33]='D2';		// D# oder E-es, schwarze Taste
X1_DateiPraefix_BildUndSound[32]='E';		//               weisse Taste
X1_DateiPraefix_BildUndSound[51]='F';		//               weisse Taste
X1_DateiPraefix_BildUndSound[36]='F2';		// F# oder G-es, schwarze Taste
X1_DateiPraefix_BildUndSound[31]='G';		//               weisse Taste
X1_DateiPraefix_BildUndSound[37]='G2';		// G# oder A-es, schwarze Taste
X1_DateiPraefix_BildUndSound[43]='A';		//               weisse Taste
X1_DateiPraefix_BildUndSound[39]='A2';		// Bb	oder B-es, rechteste klickbare schwarze Taste
X1_DateiPraefix_BildUndSound[42]='B';		//               rechteste klickbare weisse   Taste

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//
//          nicht zu verndernde interne Daten
//
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

// +++++ Datenelemente laut X1_Silverlight_DatenElementeBezeichner: Werte zu weisen
var X1_SilverlightDaten=new Array();	// wird von silverlight.js gelesen
X1_Wert=X1_Silverlight_DatenElementeWerte.length;
var X_Zahler=0;
for(X_Zahler=0;X_Zahler<X1_Wert;X_Zahler++)
{X1_SilverlightDaten[X1_Silverlight_DatenElementeBezeichner[X_Zahler]]=X1_Silverlight_DatenElementeWerte[X_Zahler];}
// Pflichtelemente werden automatisch intialisiert

// +++++ Pflicht-Elemente erzeugen und init
//                     sind mit Bezeichner fest kodiert in silverlight.js
//				    HTML-bezogene Daten wie 	onXXX-Events von HTML-Objekt
//									ID eines HTML-Objektes
//				   nicht Events oder andere Daten des Silverlight-Objektes
//						(Silverlght-Events werden in X1_GrandPiano.EventVerwaltungInstanzieren() verwaltet

// ----- Pflicht-Elemente anhngen an X1_Silverlight_DatenElementeBezeichner und Indexe merken
//				Indexe nicht als Feld sondern in Einzelvariablen speichern, deren Bezeichner besser erklrend sind.
//       Reihenfolge egal
X1_Silverlight_DatenElementeBezeichner[X1_Wert]='parentElement';
				// Kennung fr Container (z.B. DIV-Container) des HTML-Objektes (OBJECT) von Silverlight
var X1_Silverlight_DatenElementeBezeichner_parentElement_Index=X1_Wert;		// wird von silverlight.js gelesen

X1_Wert++;X1_Silverlight_DatenElementeBezeichner[X1_Wert]='inplaceInstallPrompt';	// intern, boolean
var X1_Silverlight_DatenElementeBezeichner_inplaceInstallPrompt_Index=X1_Wert;

X1_Wert++;X1_Silverlight_DatenElementeBezeichner[X1_Wert]='context';			// intern Daten-Context, String
var X1_Silverlight_DatenElementeBezeichner_context=X1_Wert;

X1_Wert++;X1_Silverlight_DatenElementeBezeichner[X1_Wert]='events'; 			// Kennung fr Eventstruktur von
														//	HTML-Events per PARAM 
var X1_Silverlight_DatenElementeBezeichner_events_Index=X1_Wert;				// wird von silverlight.js gelesen

X1_Wert++;X1_Silverlight_DatenElementeBezeichner[X1_Wert]='onError';  			// events.onError als HTML-Event
														//	per PARAM-Attribut
var X1_Silverlight_DatenElementeBezeichner_onError_Index=X1_Wert;				// wird von silverlight.js gelesen

X1_Wert++;X1_Silverlight_DatenElementeBezeichner[X1_Wert]='onLoad';			// events.onLoad  als HTML-Event
														//	per PARAM-Attribut
var X1_Silverlight_DatenElementeBezeichner_onLoad_Index=X1_Wert;				// wird von silverlight.js gelesen

// +++++ Pflicht-Elemente init
X1_SilverlightDaten[X1_Silverlight_DatenElementeBezeichner[X1_Silverlight_DatenElementeBezeichner_events_Index]]=new Array();
 														// Eventstruktur
// events.onError wird in Y_SilverlightVerwaltung_Aktivieren_InitUndStart() aus silverlight.js gefllt
// events.onLoad  wird in Y_SilverlightVerwaltung_Aktivieren_InitUndStart() aus silverlight.js gefllt
X1_SilverlightDaten[X1_Silverlight_DatenElementeBezeichner[X1_Silverlight_DatenElementeBezeichner_inplaceInstallPrompt_Index]]=false;
														// 'inplaceInstallPrompt'
														// boolean
X1_SilverlightDaten[X1_Silverlight_DatenElementeBezeichner[X1_Silverlight_DatenElementeBezeichner_context]]='';
														// 'context'
														// String

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//
//          anzupassende Routinen
//
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


// Bild- und Sound sind paarweise verfgbar und haben im Paar IDENTISCHEN Prfix, der
//		als PianoTastenID verwendet wird
//		als Suffix in x:Name von Elementen des Canvas laut X1_XAML_pathCanvas in der XAML-Datei verwendet wird
//          als Prfix in x:Name von Image und MediaElement in der XAML-Datei verwendet wird
//	Fr alle Elemente eines Canvas sollte der Wert von x:Name einmalig sein (nicht mehrfach auftreten).

// +++++ Eventverwaltung-Instanz des Grand-Piano leer erzeugen
if(!window.X1_GrandPiano){window.X1_GrandPiano={};}

// +++++ Konstruktor-Instanz der Eventverwaltung des Grand-Piano leer erzeugen
X1_GrandPiano.EventVerwaltungInstanzieren=function(){};

// +++++ Konstruktor-Instanz der Eventverwaltung des Grand-Piano deklarieren
//       per Konstruktur erzeugte Eventverwaltung bentigt instanziertes Silverlight-Objekt
//			(siehe dazu createSilverlight() aus silverlight.js)
X1_GrandPiano.EventVerwaltungInstanzieren.prototype =
{
 // ##################################################################################################
 //
 //	Anpassungen der Eventhandler, anhand derer per Silverlight animiert wird
 //		Die Events sind KEINE HTML-Events sondern Events von Silverlight.
 //		Events knnen an die Events laut PARAM des Silverlight-HTML-Objektes als OBJECT
 //				nur soweit bergeben werden, wie Silverlight die PARAM verwaltet.
 //
 //	Handler sind selbst Teil der Instanz Eventverwaltung und speichern ihre Daten dort auch
 //		(gekapselt, Nutzung des this-Zeigers auf Instanz der Eventverwaltung)
 //
 //	Es ist zu beachten, dass die Eventverwaltung browserbergreifend ist, also keine
 //		typische Internet Explorer-Eventverwaltung.
 //
 //	Die Bildanimation erfolgt per Eigenschaft .opacity eines Image-Elementes in der XAML-Datei
 //		Es wird durch Silverlight im Prinzip die folgende reine JavaScript-Variante gerendert:
 //			2 IMG berlagern sich
 //				unterste Img enthlt ungedrckte Taste und ist permanent sichtbar
 //				obere    Img enthlt gedrckte   Taste und wird ein- oder ausgeblendet per visibility
 //							Empfehlung: Jedes Img in 1 DIV-Container und diese animieren,
 //										da IMG-Objekt nicht alle Eigenschaften wie DIV hat.
 //		oder 1 Img wird im .scr wechselseitig neu belegt
 //				Img1=new Image(...); Img1.scr='....';
 //				Img2=new Image(...); Img1.scr='....';
 //				Img_ID.scr=Img1.scr;  bzw. img2.scr;
 //
 //		Man beachte: Jede gedrckte Taste erscheint nur als einzeln gedrckt. Die Bilder sind immer
 //					ber alle Tasten, so dass auch Schatteneffekte im Bild vorhanden sind, die
 //					NICHT durch Silverlight erzeugt werden: Silverlight animiert allerdings die Bilder
 //					per opacity.
 //
 // ##################################################################################################

 // +++++ berwachung der Events (lauschen / lauern auf Eventeintritt) einrichten und starten 
 Handler_SilverlightEvent_onLoad: function(control, userContext, rootElement)
 {this.control=control;
  this.rootElement = rootElement;
  this.rootElement.addEventListener("GotFocus", Silverlight.createDelegate(this, this.Handler_SilverlightEvent_onGotFocus));
  this.rootElement.addEventListener("KeyDown",  Silverlight.createDelegate(this, this.Handler_SilverlightEvent_onKeyDown));
  this.rootElement.addEventListener("KeyUp",    Silverlight.createDelegate(this, this.Handler_SilverlightEvent_onKeyUp));
  
  // Piano button event hookup: Find the button and then attach event handlers
  this.pathCanvas = rootElement.findName(X1_XAML_pathCanvas);   // "pathCanvas" laut XAML-Datei
  for(var i=0; i<this.pathCanvas.Children.Count; ++i)			// fr alle Path-Elementen in der XAML-Datei
											// 	die Maus-Eventhandler einbinden
  {this.pathCanvas.Children.GetItem(i).addEventListener		// Listener = lauschen (lauern) auf Eventeintritt
		("MouseLeftButtonDown", 					// linke Maustaste
             Silverlight.createDelegate(this, this.Handler_SilverlightEvent_onMouseDown)
            );
   this.pathCanvas.Children.GetItem(i).addEventListener		// Listener = lauschen (lauern) auf Eventeintritt
            ("MouseLeftButtonUp",						// linke Maustaste
             Silverlight.createDelegate(this, this.Handler_SilverlightEvent_onMouseUp)
            );
  }
 },

 // +++++ Reaktion auf ein vom Listener auf ein Path-Element aus XAML-Datei erkanntes MouseDown
 Handler_SilverlightEvent_onMouseDown: function(sender, eventArgs) 
 {// +++++ aktuelles Mausevent des Senders holen
  //        sender ist ein Path-Element im Canvas mit x:Name laut X1_XAML_pathCanvas in der XAML-Datei
  sender.captureMouse();
  // +++++ PianoTastenID anhand x:Name des senders ermitteln
  //        Path-Elemente der XAML-Datei haben in x:Name
  //			am Ende die Konstante laut Konstante laut X1_XAML_pathCancas_xName_Suffix
  //              und davor das PianoTastenID (welches auch identisch ist mit dem Prfix der Dateinamen der
  //								zugehrigen Bild- und Sounddatei)
  // 		x:Name des Senders besteht aus	xxYYY		
  //						mit xx  als PianoTastenID
  //                        		    YYY als Konstante laut X1_XAML_pathCancas_xName_Suffix
  //		Es muss also xx als PianoTastenID isoliert werden
  // ----- Zeiger auf x:Name-Attribut
  var Sender_NameAttribut=sender.name;
  // ----- im Wert des Attributes die Position von X1_XAML_pathCancas_xName_Suffix ermitteln
  var EndePosition=Sender_NameAttribut.indexOf(X1_XAML_pathCancas_xName_Suffix);
  // ----- PianoTastenID herauskopieren
  var PianoTastenID = Sender_NameAttribut.substr(0, EndePosition);
  // +++++ BildID des senders ermitteln
  //        Image-Elemente der XAML-Datei haben im x:Name
  //			    zu Beginn eine Konstante laut X1_XAML_IMG_xName_Praefix
  //			und danach das PianoTastenID (welches auch identisch ist mit dem Prfix der Dateinamen der
  //								zugehrigen Bild- und Sounddatei)
  // 		x:Name des Image besteht aus	XXXyy		
  //                        		mit XXX als Konstante laut X1_XAML_IMG_xName_Praefix
  //						     yy als PianoTastenID
  //		Es muss also yy als PianoTastenID isoliert werden
  var BildID = sender.findName(X1_XAML_IMG_xName_Praefix + PianoTastenID);
  // +++++ Bild-Opacity (Deckkraft) einstellen
  BildID.opacity = 1;		// Bild einblenden also gedrckte Klaviertaste anzeigen als Silverlight-Animation
  // +++++ SoundID des senders ermitteln
  //        MediaElement-Elemente der XAML-Datei haben im x:Name
  //			    zu Beginn eine Konstante laut X1_XAML_Sound_xName_Praefix
  //			und danach das PianoTastenID (welches auch identisch ist mit dem Prfix der Dateinamen der
  //								zugehrigen Bild- und Sounddatei)
  // 		x:Name des Image besteht aus	XXXyy		
  //                        		mit XXX als Konstante laut X1_XAML_Sound_xName_Praefix
  //						     yy als PianoTastenID
  //		Es muss also yy als PianoTastenID isoliert werden
  var SoundID = sender.findName(X1_XAML_Sound_xName_Praefix + PianoTastenID);
  // +++++ falls aktiv so Soundausgabe stoppen
  SoundID.stop();
  // +++++ und neu starten
  SoundID.play();
 },
    
 // +++++ Reaktion auf ein vom Listener auf ein Path-Element aus XAML-Datei erkanntes MouseUp
 Handler_SilverlightEvent_onMouseUp: function(sender, eventArgs) 
 {sender.releaseMouseCapture();
  var PianoTastenID = sender.name.substr(0, sender.name.indexOf("Path"));
  var BildID = sender.findName(X1_XAML_IMG_xName_Praefix + PianoTastenID);
  BildID.opacity = 0;		// Bild ausblenden also ungedrckte Klaviertaste anzeigen als Silverlight-Animation
 },

 // +++++ Reaktion auf ein vom Listener auf ein Path-Element aus XAML-Datei erkanntes KeyPress
 Handler_SilverlightEvent_onKeyPress: function (PianoTastenID)
 {var BildID = this.control.content.findName(X1_XAML_IMG_xName_Praefix + PianoTastenID);
  BildID.opacity = 1;		// Bild einblenden also gedrckte Klaviertaste anzeigen als Silverlight-Animation
  var SoundID = this.control.content.findName(X1_XAML_Sound_xName_Praefix + PianoTastenID);
  SoundID.stop();
  SoundID.play();
 },

 // +++++ Reaktion auf ein vom Listener auf ein Path-Element aus XAML-Datei erkanntes KeyDePress
 Handler_SilverlightEvent_onKeyDePress: function (PianoTastenID)
 {var BildID = this.control.content.findName(X1_XAML_IMG_xName_Praefix + PianoTastenID);
  BildID.opacity = 0;		// Bild ausblenden also ungedrckte Klaviertaste anzeigen als Silverlight-Animation
 },

 // +++++ Reaktion auf ein vom Listener auf ein Path-Element aus XAML-Datei erkanntes KeyDown
 Handler_SilverlightEvent_onKeyDown: function (sender, eventArgs)
 {this.Handler_SilverlightEvent_onKeyPress(X1_DateiPraefix_BildUndSound[eventArgs.Key]);},

 // +++++ Reaktion auf ein vom Listener auf ein Path-Element aus XAML-Datei erkanntes KeyUp
 Handler_SilverlightEvent_onKeyUp: function (sender, eventArgs)
 {this.Handler_SilverlightEvent_onKeyDePress(X1_DateiPraefix_BildUndSound[eventArgs.Key]);},
    
 // +++++ Reaktion auf ein vom Listener auf ein Path-Element aus XAML-Datei erkanntes gotFocus (entspricht onfocus im HTML)
 Handler_SilverlightEvent_onGotFocus: function(sender, eventArgs) 
 {// In order to avoid problems when the control looses focus while a key is held down, 
  // we use this function to reset the piano to its initial state (no key pressed). It is 
  // called on the root canvas' GotFocus event.
  var X_Zahler=0;
  for(X_Zahler=0;X_Zahler<256;X_Zahler++)
  {this.Handler_SilverlightEvent_onKeyDePress(X1_DateiPraefix_BildUndSound[X_Zahler]);}
 }
}
